(module ;; Multiple_memories.wat
  ;; Check 'multi memory' from https://webassembly.github.io/wabt/demo/wat2wasm/
  (memory $my_own_memory_0 10) ;; 10 pages...
  (memory $my_own_memory_1 20)
  (data (memory 0) (i32.const 0) "Franck") ;; String is stored in the default (0-index) memory from position '0'...
  (data (memory 1) (i32.const 0) "Bar") ;; String is stored in the (1-index) memory from position '0'...
  (data (memory $my_own_memory_1) (i32.const 3) "bier") ;; String is stored in the (1-index) memory from position '3'...
  (func (export "_start") (result i32)
    call $_ranges
    i32.sub ;; Size of string is returned
  )
  (func $_ranges (result i32 i32)
    i32.const 5 ;; Final storing position
    i32.const 0 ;; Initial storing position
  )
  (func (export "SIZE") (result i32) (memory.size)) ;; '10'
  ;; Does not work, but translation to .wasm succeeds:
  ;; (func (export "SIZE_") (result i32) (memory.size (memory $my_own_memory_1)))
  (func (export "GET") (param i32) (result i32) ;; '0' -> 70 ('F'), '1' -> 114 ('r')...
    (i32.load8_s (local.get 0))
  )
  ;; Does not work, but translation to .wasm succeeds:
  (func (export "GET_") (param i32) (result i32) ;; '0' -> 65 ('B')...
      (i32.load8_s (memory $my_own_memory_1) (local.get 0))
  )
)

;; '(;' <- is equivalent to '/*' while ';)' <- is equivalent to '*/'

(;
(func (param i32) (param f32) (local f64)
  local.get 0
  local.get 1
  local.get 2
…)
;)

;; '$' allows naming instead using numeric indexes: 0, 1, 2...
;; (func (param $first_parameter i32) (param $second_parameter f32) (local $local_variable f64)
;;   local.get $first_parameter
;;   local.get $second_parameter
;;   local.get $local_variable
;; …)

